$fn=64;
r1=5; //corner radius when viewed front/back
r2=1.5; //corner radius parallel to tripod hole
r3=20; 
b=79;	//width of the camera 
h=67.4; //height of the camera
t1=15; //thickness of the flat part
t2=27; //thickness of the lens 
w=1.5; //wall thickness

difference() {
  union() {
    case(offset=w);
    translate([-w,0,0]) hull() {
      translate([-1.5,0,h-r1-10]) rotate([90,0,0]) cylinder(r=4,h=3,center=true);
      translate([1,0,h-r1]) rotate([90,0,0]) cylinder(r=1,h=3,center=true);
      translate([1,0,h-r1-20]) rotate([90,0,0]) cylinder(r=1,h=3,center=true);
    }
  }
  translate([-3,0,h-r1-10]) rotate([90,0,0]) cylinder(r=1.5,h=3,center=true);
  case(0);
  translate([0,-t2,h]) cube([b,t2*2,41]);
  //translate([-10,-20,-10]) cube([100,100,h]);
}
translate([b/2,0,0]) rotate([90,0,0]) cylinder(d=1,h=t1-r2-r2,center=true);
translate([0,5,h-4]) rotate([90,0,0]) sphere(d=1.3);
translate([0,-5,h-4]) rotate([90,0,0]) sphere(d=1.3);
translate([b,5,h-4]) rotate([90,0,0]) sphere(d=1.3);
translate([b,-5,h-4]) rotate([90,0,0]) sphere(d=1.3);

translate([0,5,4]) rotate([90,0,0]) sphere(d=1);
translate([0,-5,4]) rotate([90,0,0]) sphere(d=1);
translate([b,5,4]) rotate([90,0,0]) sphere(d=1);
translate([b,-5,4]) rotate([90,0,0]) sphere(d=1);

module case(offset) {
  half_case(offset=offset);
  mirror ([0,1,0]) half_case(offset=offset);
}

module half_case() {
  hull() {
    translate([r1,0,r1]) rotate([-90,0,0]) cylinder(r=r1+offset,h=t1/2+offset-r2);
    translate([b-r1,0,r1]) rotate([-90,0,0]) cylinder(r=r1+offset,h=t1/2+offset-r2);
    translate([-offset,0,h-1]) cube([b+offset*2,1,1]);
    translate([r2,t1/2-r2,-offset+r1]) cylinder(r=r2+offset,h=h+offset-r1);
    translate([b-r2,t1/2-r2,-offset+r1]) cylinder(r=r2+offset,h=h+offset-r1);
  }
  intersection() {
    hull() {
      translate([b/2,-r3,h/2]) sphere(d=t2+r3*2+offset*2);
      translate([b/2,-r3,h]) sphere(d=t2+r3*2+offset*2);
    }
    translate([0,t1/2,0]) cube([b,20,h]);
  }
}
